#import "SpeedController.h"

#include <sys/sysctl.h>
#import <tzfile.h>

@implementation SpeedController

- (void)awakeFromNib
{
	[self get_info];
}

// If the user closes the search window, let's just quit
-(BOOL)windowShouldClose:(id)sender
{
    [NSApp terminate:nil];
    return YES;
}

/* ------ */
- (void)get_info
{
	//NSWindow *theWindow;
	NSDictionary *SysConfPreferences, *anarray, *anarray2;
		NSString *computername;

    SInt32 my_speed;

    int mib[2], my_memory;
    char* my_os, *my_version;
    struct timeval *last_boot;
		time_t		now;
    size_t len;

    my_speed = GetCPUSpeed();

    mib[0] = CTL_HW;
    mib[1] = HW_PHYSMEM;
    len = sizeof(my_memory);
    sysctl(mib, 2, &my_memory, &len, NULL, 0);

    mib[0] = CTL_KERN;
    mib[1] = KERN_OSTYPE;
    sysctl(mib, 2, NULL, &len, NULL, 0); my_os = malloc(len) ;
    sysctl(mib, 2, my_os, &len, NULL, 0);

    mib[0] = CTL_KERN;
    mib[1] = KERN_OSRELEASE;
    sysctl(mib, 2, NULL, &len, NULL, 0); my_version = malloc(len) ;
    sysctl(mib, 2, my_version, &len, NULL, 0);

    mib[0] = CTL_KERN;
    mib[1] = KERN_BOOTTIME;
    sysctl(mib, 2, NULL, &len, NULL, 0); last_boot = malloc(len) ;
    sysctl(mib, 2, last_boot, &len, NULL, 0);
		(void)time(&now);

		SysConfPreferences = [[NSDictionary dictionaryWithContentsOfFile:@"/var/db/SystemConfiguration/preferences.xml"] retain];
		anarray = [SysConfPreferences objectForKey:@"System"];
		anarray2 = [anarray objectForKey:@"System"];
		computername = [anarray2 objectForKey:@"ComputerName"];

    NSLog(@"Speed: %d Memory:%d",my_speed,my_memory/(1024*1024));
    NSLog(@"OS: %s %s",my_os,my_version);
    NSLog(@"Boot: %s",ctime((time_t *) &last_boot->tv_sec));
		NSLog(@"Name: %@",computername);


		//[theWindow setTitle:[NSString stringWithFormat:@"%@", computername]];

    [speedText setStringValue:[NSString stringWithFormat:@"%d MHz",my_speed]];
    [ramText setStringValue:[NSString stringWithFormat:@"%d MB",my_memory/(1024*1024)]];
    [osText setStringValue:[NSString stringWithFormat:@"%s %s",my_os,my_version]];
    [bootText setStringValue:[NSString stringWithFormat:@"%s",ctime((time_t *) &last_boot->tv_sec)]];
		[uptimeText setStringValue:[NSString stringWithFormat:@"%@",[self readable_uptime:difftime(now,last_boot->tv_sec)]]];
		[fullusername setStringValue:NSFullUserName()];
		[username setStringValue:NSUserName()];
		[computernameText setStringValue:computername];
}

- (NSMutableString 	*)readable_uptime:(time_t)uptime
{
	int 		days, hrs, mins;
	NSMutableString 	*string = [NSMutableString stringWithCapacity: 128];

	if (uptime > SECSPERMIN)
	{
		days = uptime / SECSPERDAY;
		uptime %= SECSPERDAY;
		hrs = uptime / SECSPERHOUR;
		uptime %= SECSPERHOUR;
		mins = uptime / SECSPERMIN;
		//[string appendString: @"Uptime:        "];
		if (days > 0)
			[string appendString: [NSString stringWithFormat: @"%d day%s%s", days, days > 1 ? "s" : "", (hrs || mins) ? ", " : ""]];
		if (hrs > 0 && mins > 0)
			[string appendString: [NSString stringWithFormat: @"%d:%02d", hrs, mins]];
		else
		{
			if (hrs > 0)
				[string appendString: [NSString stringWithFormat: @"%d hr%s", hrs, hrs > 1 ? "s" : ""]];
			if (mins > 0)
				[string appendString: [NSString stringWithFormat: @" %d min%s", mins, mins > 1 ? "s" : ""]];
		}

	}else
	{
		[string appendString: @"Uptime?  nah.  just Downtime here."];
	}
	[string appendString: @"\n"];
	NSLog(@"%@",string);
	return(string);
}

@end
